## org.apache.mahout.cf.taste.impl.similarity
Class SpearmanCorrelationSimilarity

    java.lang.Object
      org.apache.mahout.cf.taste.impl.similarity.SpearmanCorrelationSimilarity

All Implemented Interfaces:
  Refreshable, UserSimilarity

    public final class SpearmanCorrelationSimilarity

extends Object
implements UserSimilarity

Like `PearsonCorrelationSimilarity`, but compares relative ranking of preference values instead of preference values themselves. That is, each user's preferences are sorted and then assign a rank as their preference value, with 1 being assigned to the least preferred item.

Constructor Summary
`SpearmanCorrelationSimilarity(DataModel dataModel)`

Method Summary
`void` `refresh(Collection<Refreshable> alreadyRefreshed)` Triggers "refresh" -- whatever that means -- of the implementation.
`void` `setPreferenceInferrer(PreferenceInferrer inferrer)` Attaches a `PreferenceInferrer` to the `UserSimilarity` implementation.
`double` `userSimilarity(long userID1, long userID2)` Returns the degree of similarity, of two users, based on the their preferences.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SpearmanCorrelationSimilarity

    public SpearmanCorrelationSimilarity(DataModel dataModel)

Method Detail

### userSimilarity

    public double userSimilarity(long userID1,
                                 long userID2)
                          throws TasteException

  Description copied from interface: `UserSimilarity`

  Returns the degree of similarity, of two users, based on the their preferences.

  Specified by:
    `userSimilarity` in interface `UserSimilarity`
  Parameters:
    `userID1` - first user ID
    `userID2` - second user ID
  Returns:
    similarity between the users, in [-1,1] or `Double.NaN` similarity is unknown
  Throws:
    `NoSuchUserException` - if either user is known to be non-existent in the data
    `TasteException` - if an error occurs while accessing the data

### setPreferenceInferrer

    public void setPreferenceInferrer(PreferenceInferrer inferrer)

  Description copied from interface: `UserSimilarity`

  Attaches a `PreferenceInferrer` to the `UserSimilarity` implementation.

  Specified by:
    `setPreferenceInferrer` in interface `UserSimilarity`
  Parameters:
    `inferrer` - `PreferenceInferrer`

### refresh

    public void refresh(Collection<Refreshable> alreadyRefreshed)

  Description copied from interface: `Refreshable`

  Triggers "refresh" -- whatever that means -- of the implementation. The general contract is that any `Refreshable` should always leave itself in a consistent, operational state, and that the refresh atomically updates internal state from old to new.

  Specified by:
    `refresh` in interface `Refreshable`
  Parameters:
    `alreadyRefreshed` - `Refreshable`s that are known to have already been refreshed as a result of an initial call to a `Refreshable.refresh(Collection)` method on some object. This ensure that objects in a refresh dependency graph aren't refreshed twice needlessly.

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.